%  function y = digfil(x, a, b0, b, N)
%  digital filter
%  a = denominator array as row vector(of length N)
%  b = numerator array as row vector (of length N)
%  b0= feedthru term of numerator
%  qbuf = buffer for past values of q (of length N)

function y=digfil(x,a,b0,b,N)
persistent qbuf
if(isempty(qbuf))
    disp('initialize qbuf')
    qbuf=zeros(N,1)
end    
q=x-a*qbuf
y=b0*q +b*qbuf
qbuf=[q;qbuf(1:N-1)]  %updates qbuf
