%compress.m   
%Compression of signals.

%Wave File is read into Matlab workspace
% Replace 'gotmail' with name of your wave file.
[signal,f,Nbits]=wavread('gotmail');

% Signal is truncated to power of 2 terms
% Remove the % sign on the next 2 lines to truncate.
% NT=8192
% signal=signal(1:NT,:);

N=length(signal);
t=linspace(0,N/f,N);    % The time axis is real-time
figure(1)
plot(t,signal)


flops(0); 			% Flop counter is reset
S=fft(signal);
flop_count=flops  % Number of flops to do fft 
X=fftshift(S);
F=linspace(-f/2,f/2,N);
MX=abs(X);
figure(2)
plot(F,MX)
%Threshholding

lim=5

% The fft of the compressed signal is C
count=0;
C=zeros(size(S));		% Zeros-out C
for k=3:N
	if abs(S(k)) < lim*abs(S(2))
	C(k) = 0+0i;
	count=count+1;
	else 
	C(k)= S(k);
	end
end
display('Number of Harmonics Suppressed =')
count
display('Percentage Compression = ')
count*100/N

D=fftshift(abs(C));
figure(3)
plot(F,D)
%csig is the time-domain representation of the compressed signal
flops(0); 			%Flop counter reset
csig=ifft(C);
flop_count=flops  %Flops to do ifft
csig=real(csig);

figure(4)
plot(t,csig,t,signal)
outfile='comp_gotmail5.wav'
out=fopen(outfile,'w')
wavwrite(csig,f,Nbits,outfile)
msg=strcat('Output file:  ',outfile, ' written') 
